// --------------------------------------------------------------------------
// Scadenzario
// fv 24/8/94
// --------------------------------------------------------------------------

#include "pagament.h"
#include "saldacon.h"

#include "cg2102.h"
#include "cg2100.h"
#include "cg21sld.h"

#include <clifo.h>
#include <partite.h>
#include <scadenze.h>   
#include <pagsca.h>   

TPagamento& TPrimanota_application::pagamento() const
{ 
  CHECK(_pag, "Pagamento nullo");
  return *_pag; 
}
bool TPrimanota_application::pag_notify(TSheet_field& ps, int r, KEY k)
{                            
  TPagamento&    pag = app().pagamento();
  TMask*         msk = &(ps.mask());      
  TString_array& rws = app().pag_rows();                                
                                               
  const int rdiff = atoi(msk->get(FS_RDIFFER));
  const bool in_valuta = pag.in_valuta(); 
  const int impos = in_valuta ? 2 : 1;
  
  // ts contiene la vecchia riga, ns la nuova                                       
  TToken_string ts(128), ns(128);
  TString16 banca;

  bool doit = TRUE, m_imp = FALSE, m_perc = FALSE, m_pag = FALSE;
  bool m_scad = FALSE, m_tipo = FALSE, m_ulc = FALSE, mod = FALSE;
  word ahiahi = P_OK;                                
  
  TString news(10), newi(15), newp(15), newt(1), newu(1);                                  

  bool recalc = msk->get_bool(FS_RECALC); 
  bool mcomm  = msk->get_bool(FS_MCOMM);
  
  switch (k)
  {
  case K_ENTER:
    ns  = ps.row(r);     
    ts  = rws.row(r);    
    
    news = ns.get(0);           // Data scadenza
    newi = ns.get(impos);       // Imponibile (lire o valuta)
    newp = ns.get(3);           // Percentuale
    newt = ns.get(4);           // Tipo pagamento                                 
    newu = ns.get(5);           // Ulteriore classificazione 
    
    // qui viene il bello, si fa per dire 
    if (news != ts.get(0))  // modificata data scadenza
      mod = m_scad = TRUE;        
    if (newp != ts.get(3))  // modificata percentuale
      mod = m_perc = TRUE;        
    if (newi != ts.get(impos))  // modificato importo
    {          
       // se si modifica la percentuale l'importo non viene cagato
      if ((recalc && !m_perc) || (!recalc)) 
        mod = m_imp = TRUE;   
    }
    if (newt != ts.get(4))  // modificato tipo pagamento
      mod = m_tipo = m_ulc = TRUE;      
    
    if (newu != ts.get(5))  // modificata ulteriore classificazione
      mod = m_ulc  = TRUE;      
    break;
  case K_DEL:
  case K_INS:   
    // permette aggiunta e cancellazione solo se non c'e' 
    // ricalcolo automatico
    doit = !recalc;
    break;
  default:
    break;
  }          
  

  // settato da recalc_rate se occorre ridefinire lo sheet
  // aggiungendo o togliendo righe
  bool need_recalc = FALSE;      

  if (k == K_ENTER) 
  {
    if (mod && recalc)
    {
      // ricalcola sheet come sai fare tu
      ahiahi = pag.recalc_rate(r, m_perc, 
                               ((m_perc || m_imp) ? 
                                (m_perc ? (const char*)newp : (const char*)newi) : 
                                NULL), 
                               (m_scad ? (const char*)news : NULL),
                               (m_tipo ? (const char*)newt : NULL),
                               (m_ulc  ? (const char*)newu : NULL), 
                               rdiff, mcomm, need_recalc);
      // see if rdiff changed                          
      msk->set(FS_RDIFFER, pag.rate_differenziate() ? "1" : "2");
      msk->set(FS_NRATE, pag.n_rate());
    }
    if (!recalc)
    {                              
      ahiahi = P_OK;
      // put data as they are
      TToken_string& trw = pag.rata(r);
      TToken_string  srw = trw;
      if (m_tipo) trw.add(newt,2);
      if (m_scad) trw.add(news,3);
      if (m_imp)  
      {
        trw.add(newi,4);
        const real p = pag.recalc_percrata(r);
        ps.row(r).add(p.string(), 3);
        rws.row(r) = ps.row(r);
        ps.force_update(r); 
      }  
    }
    if (ahiahi)  // any error? Rimetti le righe com'erano prima
    {         
      if (recalc)
      {            
        TString err(80); pag.strerr(ahiahi,err);
        warning_box(err);
        ps.row(r) = rws.row(r); 
        ps.force_update(r); 
      }  
    } 
    else if (recalc && mod && need_recalc) 
    {                                   
      // ridefinisci lo sheet sulla base delle nuove rate
      pag.set_sheet(ps);
      rws = ps.rows_array();      
    } 
  }
  
  return doit;
}                            

bool TPrimanota_application::pag_sheet_handler(TMask_field& f, KEY key)
{           
  bool ok = TRUE;
  if (key == K_TAB || key == K_ENTER)
  {              
    TPagamento& pag = app().pagamento();
    const word err = pag.validate();
    if (err != P_OK)
    {
      TString s(256);
      pag.strerr(err, s);
      error_box(s); 
      ok = FALSE;
    }  
  }
  return ok;
}


bool TPrimanota_application::codpag_handler(TMask_field& f, KEY key)
{                                 
  TMask& m = f.mask();
  
  if (key == K_TAB && f.focusdirty() && m.is_running() && 
      app().is_saldaconto() && !f.mask().edit_mode())
  {
    const TString16 dt(m.get(F_DATADOC));
    app().set_pagamento(f.get(), dt);     
    app().set_scadenze(m);
  }
  return TRUE;
}

bool TPrimanota_application::numrif_handler(TMask_field& f, KEY key)
{
  bool ok = TRUE;
  if (f.to_check(key))
  {              
    TMask& m = f.mask();
    const bool empty = f.get().blank();
    if (empty && m.insert_mode())
    {                                                                
      f.set(m.get(app()._npart_is_prot ? F_PROTIVA : F_NUMDOC));
      if (m.get(F_ANNORIF).empty())
      {
        const TString& anno = m.get(F_DATADOC).right(4);
        m.set(F_ANNORIF, anno);
      }  
      if (m.get(F_CODPAG).empty())
      {
        TMask_field& clifo = m.field(app().iva() == iva_vendite ? F_CLIENTE : F_FORNITORE);
        clifo.on_hit();
      }
      return error_box("Il numero di riferimento partita e' obbligatorio!\n"
                       "Se possibile esso verra' proposto, ma potra'\n"
                       "essere modificato prima di registrare il movimento.");
    }
                              
    const TPartita* old = app().partite().first();
    if (old && empty)   // Se esisteva una partita ma ora non piu'
    { 
      const KEY k = yesnocancel_box("Attenzione la fattura della partita %d %s verra' eliminata.\n"
                                    "Premere SI per cancellarla, NO per ripristinarla, ANNULLA modificarla",
                                    old->anno(), (const char*)old->numero());
      switch (k)
      {
      case K_NO:
        m.set(F_ANNORIF, old->anno());
        m.set(F_NUMRIF, old->numero());
        break;
      case K_ESC:
        ok = FALSE;
      default:
        f.reset();
        break;
      }
    }
  }
  return ok;
}

bool TPrimanota_application::cambio_handler(TMask_field& f, KEY key)
{
  if (key == K_TAB && f.focusdirty())
  {           
    if (app().is_fattura())
    {                     
      TPagamento& pag = app().pagamento();
      const real ex(f.get());
      pag.set_cambio(ex);
      
      TMask& m = f.mask();
       if (m.insert_mode())
      {                                                          
        pag.set_rate_auto();
        TSheet_field& ps = (TSheet_field&)m.field(FS_RATESHEET); 
        pag.set_sheet(ps);
        app().pag_rows() = ps.rows_array();  
      }
      const TValuta val(m, SK_VALUTA, SK_DATACAMBIO, SK_CAMBIO);
      val.set(m, FS_VALUTA, FS_DATACAMBIO, FS_CAMBIO);
    }
  }
  return TRUE;
}

bool TPrimanota_application::reset_handler(TMask_field& f, KEY key)
{                                 
  if (key == K_SPACE)
  {                  
    TMask& m = f.mask();
    app().reset_pagamento(m);     
    app().set_scadenze(m);
  }
  return TRUE;
}

bool TPrimanota_application::recalc_handler(TMask_field& f, KEY key)
{
  if (key == K_SPACE)
  {
    const bool on = f.get().not_empty();
    const TMask& m = f.mask();
    TSheet_field& ps = (TSheet_field&)m.field(FS_RATESHEET);
    ps.enable_column(3, on); 
    TPagamento& pag = app().pagamento();
    if (pag.tipo_prima_rata() >= 4)
    {
      ps.enable_cell(0, 1, on);
      ps.enable_cell(0, 2, on);
    }
  }
  
  return TRUE;
}

bool TPrimanota_application::nrate_handler(TMask_field& f, KEY key)
{                                 
  if (key == K_TAB && f.focusdirty())
  {
    TPagamento& pag = app().pagamento();
    pag.set_numero_rate(atoi(f.get()));
    if (pag.dirty())
    {
      TMask& m = f.mask();
      TSheet_field& ps = (TSheet_field&)m.field(FS_RATESHEET);
      pag.set_sheet(ps);  
      app().pag_rows() = ps.rows_array();        
    }  
  }
  return TRUE;
}

bool TPrimanota_application::codcab_handler(TMask_field& f, KEY key)
{
  if (key == K_TAB && f.focusdirty())
  {
    const TMask& m = f.mask();
    const short id = f.dlg() == FS_NSCAB ? FS_NSABI : FS_VSABI;
    const int pos = id == FS_NSABI ? 7 : 9; // Posizione codici ABI sullo sheet
    const TString16 abi = m.get(id);
    const TString16 cab = m.get(id+1);
    TSheet_field& ps = (TSheet_field&)m.field(FS_RATESHEET);
    for (int i = ps.items()-1; i >= 0; i--) // Setta la banca in tutte le righe
    {
      TToken_string& row = ps.row(i);
      row.add(abi, pos);
      row.add(cab, pos+1);
    }
    ps.force_update();
  }
  
  return TRUE;
}

void TPrimanota_application::reset_pagamento(TMask&)
{    
  TPagamento& pag = pagamento();
  pag.read(); 
  pag.set_rate_auto(); 
}
                         
void TPrimanota_application::recalc_scadenze(const TDate& d)
{
  TPagamento& pag = pagamento();
  pag.set_inizio(d); 
  // ridefinisci lo sheet sulla base delle nuove rate
  TSheet_field& ps = pags(); 
  TString_array& rws = pag_rows();                                
 
  pag.set_sheet(ps);
  rws = ps.rows_array();  
}
                           
void TPrimanota_application::set_pagamento(const char* c, const char* d)
{ 
  if (_pag != NULL) 
  {
    delete _pag;
    _pag = NULL;  
  }  
  if (c != NULL || d != NULL)
    _pag = new TPagamento(c, d);
} 

void TPrimanota_application::set_scadenze(TMask& m)
{                                                                  
  real imponibile, imposta;
  const real spese(0.0);        
  const real cambio(m.get(SK_CAMBIO));
  TPagamento& pag = pagamento();        
  
  if (cambio <= 1.0)
  {
    imponibile = real(m.get(F_IMPONIBILI));   
    imposta = real(m.get(F_IMPOSTE));   
  }
  else
  {
    pag.set_cambio(cambio);
    imponibile = real(m.get(SK_TOTDOCVAL));   
    imposta = ZERO;   
  }  

  if (m.field(FS_RECALC).enabled())
  {
    m.set(FS_RDIFFER, pag.rate_differenziate() ? "1" : "2");
    m.set(FS_NAMEPAG, pag.name());
    m.set(FS_TIPOPR,  pag.desc_tpr());
    m.set(FS_MCOMM,   pag.mese_commerciale() ? "X" : "");
    m.set(FS_RECALC,  m.insert_mode() ? "X" : "", TRUE);
    m.set(FS_NRATE,   pag.n_rate());
  }

  pag.set_total(imponibile, imposta, spese);                              
  pag.set_rate_auto();          
  TSheet_field& ps = (TSheet_field&)m.field(FS_RATESHEET);
  pag.set_sheet(ps);               // prepara lo sheet
  _pag_rows = ps.rows_array();     // copia sheet       
}

bool TPrimanota_application::read_scadenze(TMask& m)
{                                                                  
  const TRectype& testa = _rel->curr();
  const long nreg = testa.get_long("NUMREG");
  const TString16 ndoc(testa.get("NUMDOC"));
  const int tmov = testa.get_int("TIPOMOV");
  const TDate ddoc(testa.get_date("DATADOC"));
  const TDate dreg(testa.get_date("DATAREG"));                                    
  const TString16 reg (testa.get("REG")); 
  const long protiva = testa.get_long("PROTIVA"); 
  const TString16 codcaus(testa.get("CODCAUS")); 
  const TString16 codval (testa.get("CODVAL")); 
  const real cambio(testa.get("CAMBIO")); 
  TSheet_field& ps = (TSheet_field&)m.field(FS_RATESHEET);

  real imponibile, imposta;
  const real spese(0.0);        
  
  TPagamento& pag = pagamento();        
  bool in_valuta = FALSE;
  if (cambio.sign() > 0)
  {
    in_valuta = TRUE;
    pag.set_cambio(cambio);
    imponibile = real(m.get(SK_TOTDOCVAL));   
    imposta = ZERO;      
  }
  else
  {
    imponibile = real(m.get(F_IMPONIBILI));   
    imposta = real(m.get(F_IMPOSTE));   
  }  
  pag.set_total(imponibile, imposta, spese);                              

  const TRectype& prima = _rel->cg(0);
  const char sezione    = prima.get_char("SEZIONE"); // Dare/Avere
  const int  nriga      = 1;
  const int  numrig     = 1;

  TBill clifo; clifo.get(prima);          
  const int anno = m.get_int(F_ANNORIF);
  const TString16 numpart(m.get(F_NUMRIF));
  partite().destroy();
  const TPartita& part = partite().partita(clifo, anno, numpart);
  
  int npart = part.prima_fattura(nreg);
  bool fromscratch = FALSE;

  if (npart > 0)  // la gh'e'
  {    
    const TRiga_partite&  partita   = part.riga(npart);                   
    const TRiga_scadenze& primarata = partita.rata(1);
    
    // se si e' specificato un codice pagamento diverso si rifa' da capo 
    // la follia e' che e' sulle SCADENZE, non sulle partite, naturalmente
    // uguale per tutte      
    if (pag.code() != primarata.get(SCAD_CODPAG))
      fromscratch = TRUE;                    
                         
    // se invece la maschera contiene importi diversi da quelli
    // registrati si passa la palla al culano/a                                            
    // TBC controllo se imponibile deve contenere le spese
    else 
    {
      if ((imponibile + imposta) != partita.get_real(in_valuta ? PART_IMPORTOVAL : PART_IMPORTO) || 
           imposta               != partita.get_real(PART_IMPOSTA) ||
           spese                 != partita.get_real(PART_SPESE))  
      {
        fromscratch = !yesno_box("Gli importi totali delle scadenze sono stati modificati rispetto"
                                 " all'ultima registrazione. Si desidera mantenere"
                                 " comunque la rateazione precedente");
        // nel qual caso, of course, si disabilitano gli automatismi
        m.set(FS_RECALC, fromscratch ? "X" : "", TRUE);
      }
    }  
    
    if (fromscratch)
    {
      pag.set_rate_auto();
    }  
    else
    {                       
      pag.zap_rate();
      for (int i = 1; i <= partita.rate(); i++)
      { 
        const TRiga_scadenze& scadenza = partita.rata(i);
        real  importo       = scadenza.get(SCAD_IMPORTO); 
        const TDate scad    = scadenza.get(SCAD_DATASCAD);
        const int tipop     = scadenza.get_int(SCAD_TIPOPAG);     
        const bool paid     = scadenza.get_bool(SCAD_PAGATA);
        const TString16 ulc = scadenza.get(SCAD_ULTCLASS);                       
        if (scadenza.in_valuta())
        {                                                        
          const real impval(scadenza.get(SCAD_IMPORTOVAL));
          pag.set_rata(i-1, impval, importo, scad, tipop, ulc, paid);
        }
        else
          pag.set_rata(i-1, importo, ZERO, scad, tipop, ulc, paid);
        
        TToken_string& str = ps.row(i-1);
        str.add(scadenza.get(SCAD_CODABIPR), 7);
        str.add(scadenza.get(SCAD_CODCABPR), 8);
        str.add(scadenza.get(SCAD_CODABI),   9);
        str.add(scadenza.get(SCAD_CODCAB),   10);    
        if (i == 1)
        {
          m.set(FS_NSABI, str.get(7));
          m.set(FS_NSCAB, str.get(8));
          m.set(FS_VSABI, str.get(9));
          m.set(FS_VSCAB, str.get(10));
          m.set(FS_AGENTE, scadenza.get(SCAD_CODAG));
        }
      } 
      m.set(FS_RDIFFER, pag.rate_differenziate() ? "1" : "2");
      m.set(FS_NAMEPAG, pag.name());
      m.set(FS_TIPOPR,  pag.desc_tpr());
      m.set(FS_MCOMM,   pag.mese_commerciale() ? "X" : "", TRUE);
      m.set(FS_RECALC,  m.insert_mode() ? "X" : "", TRUE);
      m.set(FS_NRATE,   pag.n_rate());
    } //else
  }
  else
    return FALSE;

  pag.set_sheet(ps);
  _pag_rows = ps.rows_array();

  // se la prima rata e' fissa non si tocca
  if (pag.tipo_prima_rata() > 3)
    ps.disable_cell(0,-1);
  
  return TRUE;
}

void TPrimanota_application::write_scadenze(const TMask& m)
{                    
  const long nreg = m.get_long(F_NUMREG);
  const int anno  = m.get_int(F_ANNORIF);
  const TString numpart(m.get(F_NUMRIF));
  
  TPartita* oldgame = partite().first();
  TPartita* newgame = NULL;

  if (anno > 0 && !numpart.blank())
  {
    real imponibile(0.0);   
    real imposta(0.0);   
    real spese(0.0);                           
                                 
    const TString ndoc(m.get(F_NUMDOC));
    const int tmov = causale().tipomov();
    const TDate   ddoc(m.get(F_DATADOC));
    const TDate   dreg(m.get(F_DATAREG));                                    
    const TString reg (causale().reg().name());       
    const TString desc(m.get(F_DESCR));
    const long protiva = m.get_long(F_PROTIVA); 
    const TString codcaus(causale().codice()); 
    const TString codval (m.get(SK_VALUTA)); 
    const real cambio (m.get(SK_CAMBIO)); 
    const TString agente (m.get(FS_AGENTE)); 
    const char sezione = get_cgs_imp(0).sezione();        // Dare/Avere
 
    const TBill clifo(cgs().row(0), 2, 0x3);                    
    newgame = new TPartita(clifo, anno, numpart);
  
    const int row = newgame->prima_fattura(nreg);
    TRiga_partite& partita = row <= 0 ? newgame->new_row() : newgame->riga(row);
    TPagamento& pag = pagamento();                      
                          
    // put data on partita
    partita.put(PART_TIPOMOV, tmov);
    partita.put(PART_NREG,    nreg);
    partita.put(PART_NUMRIG,  1);
    partita.put(PART_DATAREG, dreg); 
    partita.put(PART_DATADOC, ddoc);
    partita.put(PART_NUMDOC,  ndoc);
    partita.put(PART_DESCR,   desc);
    partita.put(PART_CODCAUS, codcaus);
    partita.put(PART_REG,     reg);
    partita.put(PART_PROTIVA, protiva);
    partita.put(PART_SEZ,     sezione);
    partita.put(PART_CODVAL,  codval);
    partita.put(PART_CAMBIO,  cambio);
    
    if (partita.in_valuta())    
    {                                              
      partita.put(PART_IMPORTO, m.get(F_IMPONIBILI));
      partita.put(PART_IMPORTOVAL, pag.imponibile());
      partita.zero(PART_IMPOSTA);
    }
    else
    {
      partita.put(PART_IMPORTO, real(pag.imponibile()+pag.imposta()));
      partita.zero(PART_IMPORTOVAL);
      partita.put(PART_IMPOSTA, pag.imposta());
    }  
    partita.put(PART_SPESE,   pag.spese());
  
    TSheet_field& ps = (TSheet_field&)m.field(FS_RATESHEET);
    partita.elimina_rata(-1);
    for (int i = 0; i < pag.n_rate(); i++)
    {    
      TToken_string& row = ps.row(i);
      
      TRiga_scadenze& scadenza = partita.new_row(); 
      scadenza.put(SCAD_CODPAG,   pag.code());
      scadenza.put(SCAD_TIPOPAG,  pag.tipo_rata(i));
      scadenza.put(SCAD_ULTCLASS, pag.ulc_rata(i));
      if (partita.in_valuta())    
      {
        scadenza.put(SCAD_IMPORTO, pag.tlit_rata(i));
        scadenza.put(SCAD_IMPORTOVAL, pag.tpay_rata(i));
      }
      else
      {
        scadenza.put(SCAD_IMPORTO, pag.tpay_rata(i));
        scadenza.zero(SCAD_IMPORTOVAL);
      }  
      scadenza.put(SCAD_DATASCAD, pag.data_rata(i));
      scadenza.put(SCAD_CODABIPR, row.get(7));    
      scadenza.put(SCAD_CODCABPR, row.get(8));    
      scadenza.put(SCAD_CODABI,   row.get(9));    
      scadenza.put(SCAD_CODCAB,   row.get(10));    
      scadenza.put(SCAD_CODAG,    agente);
      scadenza.put(SCAD_PAGATA,   pag.ratapagata(i));
    }
  }

  if (oldgame != NULL)
  {
    const int rigafatt = oldgame->prima_fattura(nreg);
    if (rigafatt > 0)
    {
      if (newgame == NULL || *oldgame != *newgame)
      {        
        bool sposta = newgame != NULL;
        if (sposta)
        {                   
          sposta = (oldgame->conto().sottoconto() == newgame->conto().sottoconto());
          if (sposta)
            sposta = yesno_box("Spostare le righe nella nuova partita?");
        }  
        if (sposta)                        
          oldgame->sposta_riga(rigafatt, *newgame);
        else  
        {
          oldgame->scollega_pagamenti(rigafatt);
          oldgame->rimuovi_riga(rigafatt);
        }  
        oldgame->rewrite();
      }
      else
      {     
        oldgame->sposta_riga(rigafatt, *newgame);
      }
    }  
  } 
  
  if (newgame != NULL)           // Se non ho cancellato il numero partita ...
    newgame->write();            // Salva nuova partita
}


///////////////////////////////////////////////////////////
// Gestione pagamenti
///////////////////////////////////////////////////////////

bool TPrimanota_application::showpartite_handler(TMask_field& f, KEY k)
{          
  bool ok = TRUE;
  TMask& m = f.mask();
  
  const char tipo = m.get(116)[0];
  if (tipo == 'K' || (tipo == 'T' && app().causale().tipomov() == 2))
  {
    TSheet_field& s = *m.get_sheet();   
    const int riga = s.selected();

    if (k == K_SPACE)
    {
      const bool ok = app().edit_partite(m, riga);
      if (ok && riga < s.items())
        k = K_ENTER;
    } 
    
    if (k == K_ENTER)
    {                                
      const long curreg = app().curr_mask().get_long(F_NUMREG);
      const TImporto importo(app().get_cgs_imp(riga));
      const TImporto speso(app().partite().importo_speso(curreg, riga+1));
      if (importo != speso)
      { 
        const char* ss = speso.valore().string(".");
        return f.error_box("L'importo deve essere %s %c", ss, speso.sezione());
      }
      if (tipo == 'K' && !speso.is_zero())
        app().disable_cgs_cells(riga, 'K');
    }  
  }
  return ok;
}


// deleting significato
//  -1      sto cancellando tutto
//   0      non sto cancellando nulla
//   1      sto cancellando la prima riga contabile
//   n      sto cancellando la ennesima riga contabile
bool TPrimanota_application::notify_edit_pagamento(TPartita& p, TRectype& new_pag, 
                                                   const TValuta& valuta, int deleting)
{   
  const int nriga = new_pag.get_int(PAGSCA_NRIGA);       // Riga fattura
  const int nrata = new_pag.get_int(PAGSCA_NRATA);       // Numero rata
  const int nrigp = new_pag.get_int(PAGSCA_NRIGP);       // Riga pagamento
  const TRectype& old_pag = p.pagamento(nriga, nrata, nrigp);
  const TRiga_partite& somma = p.riga(nrigp);
  const int riga_contabile = somma.get_int(PART_NUMRIG); // Riga movimento

  if (deleting >= 0)
  {
    const char sez = somma.sezione();                    // Sezione importo e ritenute
    const char controsez = sez == 'A' ? 'D' : 'A';       // Sezione contropartita

    // Aggiornamento contopartita
    const TImporto old_importo(controsez, old_pag.get_real(PAGSCA_IMPORTO));
    TBill old_conto; old_conto.get(old_pag, TRUE);

    const TImporto new_importo(controsez, new_pag.get_real(PAGSCA_IMPORTO));   
    TBill new_conto; new_conto.get(new_pag, TRUE);

    if (old_importo != new_importo || old_conto != new_conto)
    {
      const int old_riga = bill2pos(old_conto, 'I');
      if (old_riga >= 0)
      {
        const bool empty = sub_cgs_imp(old_riga, old_importo);
        if (empty && (new_importo.is_zero() || new_conto != old_conto))
          reset_cgs_row(old_riga);
      }  
      
      // Importo della contropartita
      if (!new_importo.is_zero() && new_conto.ok())
      {
        const int new_riga = bill2pos(new_conto, 'I');
        if (new_riga < 0)
          set_cgs_row(new_riga, new_importo, new_conto, "", 'I');
        else
          add_cgs_imp(new_riga, new_importo);  
      }    
    }
    
    // Aggiornamento ritenute
    const real old_ritenute(old_pag.get(PAGSCA_RITENUTE));
    const real new_ritenute(new_pag.get(PAGSCA_RITENUTE));    
    if (old_ritenute != new_ritenute)
    { 
      const TImporto grow_ritenute(controsez, new_ritenute-old_ritenute); 
      const riga = type2pos('F');
      if (riga < 0)
      {
        TBill conto_rit; causale().bill(11, conto_rit);
        const TString desc(causale().desc_agg(11));
        set_cgs_row(riga, grow_ritenute, conto_rit, desc, 'F');
      }
      else 
      {
        const bool empty = add_cgs_imp(riga, grow_ritenute);
        if (empty) reset_cgs_row(riga);
      }  
    }
  }      // if (deleting != 0)
  
  char old_ap, new_ap;
  TImporto old_abbuono, new_abbuono, old_diffcam, new_diffcam;
  const bool empty = p.modifica_pagamento(new_pag, valuta,
                                          old_ap, old_abbuono, old_diffcam, 
                                          new_ap, new_abbuono, new_diffcam, TRUE);
  
  if (deleting >= 0)
  {
    // Se c'e' differenza negli abbuoni
    if (old_abbuono != new_abbuono || old_ap != new_ap) 
    {
      if (old_ap != ' ')   // Se c'era un abbuono ...
      { 
        const int riga_abb = type2pos(old_ap);
        CHECK(riga_abb >= 0, "Chiss'e' fregato gli abbuoni?");
        const bool empty = add_cgs_imp(riga_abb, old_abbuono);       
        if (empty && new_ap != old_ap)
          cgs().destroy(riga_abb);
        
        if (deleting != riga_contabile)
        {
          // Sottrae l'abbuono con la sezione invertita dalla riga contabile
          sub_cgs_imp(riga_contabile-1, old_abbuono); 
        }  
      }                     
      if (new_ap != ' ')                            // Se ci sono abbuoni
      {                                       
        const riga_abb = type2pos(new_ap);

        new_abbuono.swap_section();
        new_abbuono.normalize();

        if (riga_abb < 0)
        {                           
          const int rc = new_ap == 'A' ? 9 : 8;
          TBill conto_abb; causale().bill(rc, conto_abb);
          const TString desc(causale().desc_agg(rc));
          app().set_cgs_row(riga_abb, new_abbuono, conto_abb, desc, new_ap);
        }
        else
          add_cgs_imp(riga_abb, new_abbuono);
        
        if (deleting != riga_contabile)
        {
          // Aggiunge l'abbuono con la sezione invertita
           sub_cgs_imp(riga_contabile-1, new_abbuono);     
        }  
      }  
    }
    
    // Se c'e' variazione nella differenza cambi
    if (old_diffcam != new_diffcam)                 
    {
      const int riga_diffcam = type2pos('C');
      TImporto grow_diffcam(old_diffcam); 
      grow_diffcam -= new_diffcam;
      grow_diffcam.normalize();
      
      if (riga_diffcam < 0)
      {
        TBill conto_diffcam; causale().bill(12, conto_diffcam);
        const TString desc(causale().desc_agg(12));
        set_cgs_row(riga_diffcam, grow_diffcam, conto_diffcam, desc, 'C');
      }
      else
      {
        const bool empty = add_cgs_imp(riga_diffcam, grow_diffcam);
        if (empty) cgs().destroy(riga_diffcam);
      }  
      
      if (deleting != riga_contabile)
      {
        // Aggiunge la differenza con la sezione invertita
        sub_cgs_imp(riga_contabile-1, grow_diffcam);  
      }  
    }
  }     // if (deleting >= 0)
  
  return empty;
}

// Scorre tutte le righe della partita ed azzera i pagamenti relativi a alla riga contabile
// cancellata e decrementa i numeri riga superiori a numrig
bool TPrimanota_application::notify_cgline_deletion(TPartita& partita, long nreg, int numrig)
{                    
  bool found = FALSE;

  for (int p = partita.last(); p > 0; p = partita.pred(p))
  {
    TRiga_partite& part = partita.riga(p);
    if (part.is_fattura())
    {
      for (int r = part.rate(); r > 0; r--)
      {
        const TRiga_scadenze& scad = part.rata(r);
        for (int s = scad.last(); s > 0; s = scad.pred(s))
        {
          const TRiga_partite& sum = partita.riga(s);
          if (sum.get_long(PART_NREG) == nreg && 
              (numrig <= 0 || sum.get_int(PART_NUMRIG) == numrig))
          {
            TRectype nul_pag(scad.row(s));
            nul_pag.zero(PAGSCA_IMPORTO);
            nul_pag.zero(PAGSCA_IMPORTOVAL);
            nul_pag.zero(PAGSCA_RITENUTE);               
            nul_pag.put(PAGSCA_ACCSAL, 'A');
            const TValuta val;           // Non cambiare valuta
            notify_edit_pagamento(partita, nul_pag, val, numrig);
            found = TRUE;
          }
        }
      }
    } 
    else 
    {
      if (numrig > 0 && part.get_long(PART_NREG) == nreg && part.get_int(PART_NUMRIG) > numrig)
        part.put(PART_NUMRIG, numrig-1);
    }    
  }

  TRecord_array& unas = partita.unassigned();
  for (int u = unas.last_row(); u > 0; u = unas.pred_row(u))
  {
    const TRiga_partite& sum = partita.riga(u);
    if (sum.get_long(PART_NREG) == nreg && 
        (numrig <= 0 || sum.get_int(PART_NUMRIG) == numrig))
    {
      TRectype nul_pag(unas.row(u, FALSE));
      nul_pag.zero(PAGSCA_IMPORTO);
      nul_pag.zero(PAGSCA_IMPORTOVAL);
      nul_pag.zero(PAGSCA_RITENUTE);               
      nul_pag.put(PAGSCA_ACCSAL, 'A');   // Inutile, ma l'ho copiato da sopra
      const TValuta val;                 // Non cambiare valuta
      notify_edit_pagamento(partita, nul_pag, val, numrig);
      found = TRUE;
    }
  }
  
  return found;
}

bool TPrimanota_application::notify_cgline_deletion(int numrig)
{
  bool found = FALSE;
  const long nreg = curr_mask().get_long(F_NUMREG);
  for (TPartita* game = partite().first(); game; game = partite().next())
    found |= notify_cgline_deletion(*game, nreg, numrig);
  return found;
}
